"use strict";

var _core = require("babel-runtime/core-js")["default"];

var _interopRequire = require("babel-runtime/helpers/interop-require")["default"];

module.exports = fastpather;

var fastpath = _interopRequire(require("./lib/fastPath"));

function fastpather(pattern) {
    var input = {};
    var output = {};
    if (typeof pattern === "string") {
        //simple string patterns
        return fastpath(pattern);
    } else {
        var _ret = (function () {
            //named patterns
            var keys = _core.Object.keys(pattern);
            keys.forEach(function (key) {
                return input[key] = fastpath(pattern[key]);
            });
            return {
                v: {
                    evaluate: function evaluate(obj) {
                        keys.forEach(function (key) {
                            return output[key] = input[key].evaluate(obj);
                        });
                        return output;
                    }
                }
            };
        })();

        if (typeof _ret === "object") {
            return _ret.v;
        }
    }
}